import type * as React from 'react';
import type { Theme } from '../styles/types';
import type { Override } from '../helpers/overrides';
export declare type BaseProviderOverrides = {
    AppContainer?: Override;
    LayersContainer?: Override;
};
export declare type BaseProviderProps = {
    /** Children element to be rendered. Normally the BaseProvider
     should be added at the top level of an application. */
    children: React.ReactNode | undefined | null;
    overrides?: BaseProviderOverrides;
    /** The base theme to be used in the application. */
    theme: Theme;
    /** A value of z-index to be set on the layers. */
    zIndex?: number;
};
