import type * as React from 'react';
import type { Override } from '../helpers/overrides';
export declare type IconOverrides = {
    Svg?: Override;
};
export declare type Size = number | string;
export declare type Color = string;
export declare type StyledComponentArgs = {
    $size?: Size;
    $color?: Color;
};
export declare type IconProps = React.SVGAttributes<SVGElement> & {
    children?: React.ReactNode;
    /** Size of element, will be passed to the svg width/height style. Can also be a value included in */
    size?: Size;
    /** Color of icon, will be used as svg fill */
    color?: Color;
    /** Allows you to set the SVG `<title>` label, which is used for accessibility */
    title?: string;
    overrides?: IconOverrides;
} & StyledComponentArgs;
