import type { ArrowStylePropsArg, BodyStylePropsArg, InnerStylePropsArg } from './types';
import type { Theme } from '../styles/types';
import type { StyleObject } from 'styletron-standard';
/**
 * Main popover container element that gets positioned next to the anchor
 */
export declare function getBodyStyles(props: BodyStylePropsArg & {
    $theme: Theme;
}): StyleObject;
export declare const Body: import("styletron-react").StyletronComponent<"div", BodyStylePropsArg>;
/**
 * Arrow shown between the popover and the anchor element
 */
export declare function getArrowStyles(props: ArrowStylePropsArg & {
    $theme: Theme;
}): StyleObject;
export declare const Arrow: import("styletron-react").StyletronComponent<"div", ArrowStylePropsArg>;
/**
 * Extra div that holds the popover content. This extra element
 * is needed for the arrow–the arrow is just a 45deg rotated div,
 * and rendering this extra element on top with a solid background
 * clips the part of the arrow that extends into the popover.
 */
export declare function getInnerStyles({ $theme }: {
    $theme: Theme;
}): StyleObject;
export declare const Inner: import("styletron-react").StyletronComponent<"div", InnerStylePropsArg>;
/**
 * A drop-in component that provides the recommended padding
 * for popovers. Mostly a convenience for users so they don't
 * have to define this themselves.
 */
export declare const Padding: import("styletron-react").StyletronComponent<"div", {}>;
export declare const Hidden: import("styletron-react").StyletronComponent<"div", {}>;
