import type { Theme } from '../styles/types';
import type { Override } from '../helpers/overrides';
export declare type RatingOverrides = {
    Root?: Override;
    Item?: Override;
};
export declare type StarRatingProps = {
    overrides?: RatingOverrides;
    /** The current rating value. */
    value?: number;
    /** The total number of items to display. */
    numItems: number;
    readOnly?: boolean;
    /** Callback that's called with the newly selected value. */
    onChange?: (a: {
        value: number;
    }) => unknown;
    size?: number;
};
export declare type EmoticonRatingProps = {
    overrides?: RatingOverrides;
    /** The current rating value. */
    value?: number;
    readOnly?: boolean;
    /** Callback that's called with the newly selected value. */
    onChange?: (a: {
        value: number;
    }) => unknown;
    size?: number;
};
export declare type RatingState = {
    previewIndex?: number;
    isFocusVisible?: boolean;
};
export declare type StyledRootProps = {
    $theme: Theme;
};
export declare type StyledRatingItemProps = {
    $theme: Theme;
    $isActive: boolean;
    $isPartialActive: boolean;
    $isSelected: boolean;
    $isFocusVisible: boolean;
    $isReadOnly: boolean;
    $index: number;
    $size: number;
};
